
/*
* WICHTIG: Unter "Werkzeuge->EraseFlash" werden die alten Daten durch "All Flash Contents" gelöscht. Daher zu Beginn auf "Only Sketch" stellen, es sei denn, man möchte den Speicher löschen.
* Flash-Size: FS3MB
* 
* 
* Um die Daten auszulesen, den ESP anschließen, mit moserial /dev/ttyUSB0 öffnen (115200), in Datei aufnehmen und nochmal resetten, um die Ausgabe erneut zu starten.
*/
#include <FS.h>
#include <LittleFS.h>
#include <time.h>
#include <ESP8266WiFi.h>

#define detect_pin D2
#define LEDPin D4

#ifndef STASSID

#define STASSID "Schmartfon"
#define STAPSK "xxxxxxxxxxxx"
 
#define STASSID2 "dkiste"
#define STAPSK2 "yyyyyyyyyyy"
#endif

const char *ssid = STASSID;
const char *pass = STAPSK;

const char *ssid2 = STASSID2;
const char *pass2 = STAPSK2;

long timezone = 1;
byte daysavetime = 1;

double CP10sA;
double CP10s;
unsigned int Count = 0;                // Laut https://www.dfrobot.com/product-2547.html ist das MaxRange 1200µSv/h, das würde in 3,141 Sekunden 1200µSv/h * 153,8 CPM/(µSv/h) / 60 s/min * 3,141 s = 9662 Counts ergeben. Daher müsste ein unsigned short reichen.
                                         // Ein unsigned short ist beim ESP8226  2Byte groß, daher Wertebereich 0 bis 65535
                                         // Ein unsigned int ist 4Byte große, Wertebereich 0 bis 4294967295. Sicher ist sicher.
boolean anfang = true;

void IRAM_ATTR GeigerIsr()
{
    if (anfang) 
      digitalWrite(LEDPin,!digitalRead(LEDPin));
    CP10sA++;
    Count++;
    //digitalWrite(LEDPin,!digitalRead(LEDPin));
}

void IRAM_ATTR timer1ISR()
{
    CP10sA = CP10sA * 10.0 / 11.0;
    CP10s = CP10sA;
//digitalWrite(D4, !digitalRead(D4));
//digitalWrite(D4, !digitalRead(D4));
}

void setTimerInterrupt()
{
    timer1_attachInterrupt(timer1ISR);
/* Prescalers:
TIM_DIV1      80MHz => 80 ticks/µs => Max: (2^23 / 80) µs =  ~0.105s
TIM_DIV16     5MHz  => 5 ticks/µs => Max: (2^23 / 5) µs = ~1.678s
TIM_DIV256    0.3125MHz => 0.3125 ticks/µs => Max: (2^23 / 0,3125) µs = ~26.8s
Interrupt TYPE:
TIM_EDGE      no other choice here
Repeat?:
TIM_SINGLE  0 => one time interrupt, you need another timer1_write(ticks); to restart
TIM_LOOP    1 => regular interrupt 
*/
    timer1_enable(TIM_DIV16, TIM_EDGE, TIM_LOOP);
    timer1_write(2500000 * 2);  // 2500000 *2 / 5 ticks/µs => 1s interval 
}

double getCPM()
{
    return CP10s * 6.0;           // mit 6 Multiplizieren, da oben der Faktor 10/11 gewählt wurde. Stichwort Geometrische Reihe
}

double getnSvPh()
{
    return (getCPM()/153.8*1000.0);
}

void readFile(const char *path)
{
//Serial.printf("Reading file: %s\n", path);

    File file = LittleFS.open(path, "r");
    if (!file) {
        Serial.println("Failed to open file for reading");
        return;
    }
//Serial.print("Read from file: ");
    while (file.available()) {
        Serial.write(file.read());
    }
    file.close();
}

void writeFile(const char *path, const char *message)
{
    Serial.printf("Writing file: %s\n", path);

    File file = LittleFS.open(path, "w");
    if (!file) {
        Serial.println("Failed to open file for writing");
        return;
    }
    if (file.print(message)) {
        Serial.println("File written");
    } else {
        Serial.println("Write failed");
    }
    delay(2000);                // Make sure the CREATE and LASTWRITE times are different
    file.close();
}

void appendFile(const char *path, const char *message)
{
    if (anfang) digitalWrite(LEDPin,0);
//Serial.printf("Appending to file: %s\n", path);

    File file = LittleFS.open(path, "a");
    if (!file) {
        Serial.println("Failed to open file for appending");
        return;
    }
    if (anfang) digitalWrite(LEDPin,!digitalRead(LEDPin));
    if (file.print(message)) {
// Serial.println("Message appended");
    } else {
        Serial.println("Append failed");
    }
    if (anfang) digitalWrite(LEDPin,!digitalRead(LEDPin));
    file.close();
    if (anfang) digitalWrite(LEDPin,!digitalRead(LEDPin));
}

void mountFS()
{
    if (!LittleFS.begin()) {
        Serial.println("LittleFS mount failed");
        return;
    } else {
//Serial.println("Little FS Mounted Successfully");
    }
    bool fileexists = LittleFS.exists("/data.txt");
// Serial.print(fileexists);
    if (!fileexists) {
        Serial.println("File doesn’t exist");
        Serial.println("Creating file...");
// Create File and add header
        writeFile("/data.txt", "Geigerzähler v. 1.2\r\n");
    } else {
//Serial.println("File already exists");
        readFile("/data.txt");  // Read the contents of the file
    }
}

void stopWiFiAndSleep() {
  wifi_set_sleep_type(MODEM_SLEEP_T);
  delay(200);
  WiFi.disconnect();
  WiFi.mode(WIFI_OFF);
  WiFi.forceSleepBegin();
  delay(100);
}

void makeWifiConnection()
{
    WiFi.begin(ssid, pass);
    long t;
    t = millis();

    while (WiFi.status() != WL_CONNECTED && millis() - t < 20000) {
        delay(500);
//Serial.print(".");
    }
    if (millis() - t > 20000) {
          WiFi.begin(ssid2, pass2);
          
          t = millis();

          while (WiFi.status() != WL_CONNECTED && millis() - t < 20000) {
              delay(500);
//Serial.print(".");
          }
    }
//Serial.print("\n");
    if (millis() - t < 20000) {
//Serial.println("WiFi connected");
//Serial.println("IP address: ");
//Serial.println(WiFi.localIP());
//Serial.println("Contacting Time Server");
        configTime(3600 * timezone, daysavetime * 3600, "time.nist.gov", "0.pool.ntp.org", "192.168.3.0");
        struct tm tmstruct;
/* 
Struktur tm
tm_hour -> Stunde: 0 bis 23
tm_min -> Minuten: 0 bis 59
tm_sec -> Sekunden 0 bis 59
tm_mday -> Tag 1 bis 31
tm_wday -> Wochentag (0 = Sonntag, 6 = Samstag)
tm_mon -> Monat: 0 (Januar) bis 11 (Dezember)
tm_year -> Jahre seit 1900
tm_yday -> vergangene Tage seit 1. Januar des Jahres
tm_isdst -> Wert > 0 = Sommerzeit (dst = daylight saving time)
*/
        delay(2000);
        tmstruct.tm_year = 0;
        getLocalTime(&tmstruct, 5000);
//Serial.printf("\nNow is : %d-%02d-%02d %02d:%02d:%02d\n", (tmstruct.tm_year) + 1900, (tmstruct.tm_mon) + 1, tmstruct.tm_mday, tmstruct.tm_hour, tmstruct.tm_min, tmstruct.tm_sec);
        Serial.
            printf((String(tmstruct.tm_mday) + "." + String((tmstruct.tm_mon) + 1) + "." +
                    String((tmstruct.tm_year) + 1900) + " " + String(tmstruct.tm_hour) + ":" + String(tmstruct.tm_min) +
                    ":" + String(tmstruct.tm_sec) + "\r\n").c_str());
        appendFile("/data.txt", ("\r\nZeit Counts nSv/h \r\n"+String(millis() / 1000.0) + " 0 195.06     ").c_str());
        appendFile("/data.txt", (String(tmstruct.tm_mday) + "." + String((tmstruct.tm_mon) + 1) + "." + String((tmstruct.tm_year) + 1900) + " " + String(tmstruct.tm_hour) + ":" + String(tmstruct.tm_min) + ":" + String(tmstruct.tm_sec) + "\r\n").c_str());  //Append data to the file
    } else                      //kein Time-Server
    {
        appendFile("/data.txt", "\r\nZeit Counts nSv/h \r\n00.00 0 195.06     ZeitServer nicht erreichbar \r\n");
    }

    stopWiFiAndSleep();

    
}

void start()
{
    digitalWrite(LEDPin, 1);
    CP10s = 5.0;    // Startwert entspricht etwa der Nullrate. Eigentlich ist dies die Anzahl der Impulse in 10 Sekunden, da mit 6 multipliziert wird.
    CP10sA = 5.0;
    attachInterrupt(digitalPinToInterrupt(detect_pin), GeigerIsr, FALLING);
    setTimerInterrupt();
    Serial.end();
}

void setup()
{   
// put your setup code here, to run once:
    pinMode(detect_pin, INPUT);
    pinMode(LEDPin, OUTPUT);
    Serial.begin(115200);
//Serial.println("Mount LittleFS");
    Serial.println("");
    mountFS();
    makeWifiConnection();
    start();
}

void loop()
{
    unsigned int CountSpeicher;
//for (int i =0; i< random (0, 7); i++)   //Test
//{
//  CPM++;
//  Count++;
//}
    delay(3141);
    CountSpeicher = Count;
    Count = 0;
    if (anfang && millis() > 100000)
    {
      anfang=false;
      digitalWrite(LEDPin, 1);
      pinMode(LEDPin, INPUT);
    }
//   Serial.println(getuSvph());
    appendFile("/data.txt", (String(millis() / 1000.0) + " " + String(CountSpeicher) + " " + String(getnSvPh()) + "\r\n").c_str());       //Append data to the file
}